package dev.guoping.app_info.utils;

import android.text.TextUtils;

import java.util.UUID;

import dev.guoping.app_info.utils.local_data.SdData;
import dev.guoping.app_info.utils.local_data.SpData;

public class DeviceId {

    private DeviceId() {
        throw new UnsupportedOperationException("DeviceId cannot be instantiated");
    }

    private static String id;

    private static SdData sdData = SdData.getInstance("com.gplibs.utils.device_state");
    private static SpData spData = SpData.getInstance("com.gplibs.utils.device_state");

    public static synchronized String get() {
        if (TextUtils.isEmpty(id)) {
            id = spData.get("device_id", String.class);
        }
        if (!TextUtils.isEmpty(id)) {
            return id;
        }

        String sdId = getSdcardDeviceId();
        if (!TextUtils.isEmpty(sdId)) {
            id = sdId;
        }
        if (TextUtils.isEmpty(id)) {
            id = createSdcardId();
        }
        try {
            id = UUID.nameUUIDFromBytes(id.getBytes("utf-8")).toString();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        spData.set("device_id", id);
        return id;
    }

    private static String getSdcardDeviceId() {
        return sdData.get("device_id", String.class);
    }

    private static String createSdcardId() {
        String id = UUID.randomUUID().toString();
        sdData.set("device_id", id);
        return id;
    }
}
