package dev.guoping.app_info.utils.local_data;

import android.text.TextUtils;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

import java.lang.reflect.Modifier;
import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.Map;

class LocalData {

    private static Gson gson = new GsonBuilder()
            .excludeFieldsWithModifiers(Modifier.PRIVATE, Modifier.PROTECTED, Modifier.STATIC)
            .create();

    protected String instanceKey;
    private Map<String, Object> objects = new HashMap<>();

    LocalData(String instanceKey) {
        this.instanceKey = instanceKey;
        init();
    }


    protected void init(){}

    public Map<String, ?> getAll() { return null; }

    protected String get(String key, String def) { return def; }

    protected void put(String key, String value) {}

    protected void remove(String key) {}

    protected void clear() {}


    public static <T> String serialization(T obj) {
        return obj == null ? "" : gson.toJson(obj);
    }

    public static <T> String serialization(T obj, Type type) {
        return obj == null ? "" : gson.toJson(obj, type);
    }

    public static <T> T deserialization(String data, Class<T> clazz) {
        return TextUtils.isEmpty(data)? null : (T) gson.fromJson(data, clazz);
    }

    public static <T> T deserialization(String data, Type type) {
        return TextUtils.isEmpty(data)? null : (T) gson.fromJson(data, type);
    }

    public synchronized <T> void set(String key, T value) {
        synchronized (this) {
            try {
                if (value == null) {
                    remove(key);
                } else {
                    put(key, gson.toJson(value));
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
            if (value == null) {
                objects.remove(key);
            } else {
                objects.put(key, value);
            }
        }
    }

    public synchronized <T> T get(String key, Type type) {
        synchronized (this) {
            try {
                if (objects.containsKey(key)) {
                    return (T) objects.get(key);
                }
                String data = get(key, "");
                if (TextUtils.isEmpty(data)) {
                    return null;
                } else {
                    T r = (T) gson.fromJson(data, type);
                    objects.put(key, r);
                    return r;
                }
            } catch (Exception e) {
                return null;
            }
        }
    }
}
