package dev.guoping.app_info.utils.local_data;

import android.content.Context;
import android.content.SharedPreferences;

import java.util.HashMap;
import java.util.Map;

import dev.guoping.app_info.utils.AppInfoPluginUtils;

/**
 * Created by guoping on 2017/8/4.
 */

public class SpData extends LocalData {

    private static Map<String, SpData> instances = new HashMap<>();

    public static SpData getInstance(String instanceKey) {
        if (!instances.containsKey(instanceKey)) {
            instances.put(instanceKey, new SpData(instanceKey));
        }
        return instances.get(instanceKey);
    }

    private SharedPreferences spf;
    private SharedPreferences.Editor editor;

    SpData(String instanceKey) {
        super(instanceKey);
    }

    @Override
    protected void init() {
        spf = AppInfoPluginUtils.getContext().getSharedPreferences("sp_data_" + instanceKey, Context.MODE_PRIVATE);
        editor = spf.edit();
    }

    @Override
    public Map<String, ?> getAll() {
        return spf.getAll();
    }

    @Override
    protected String get(String key, String def) {
        return spf.getString(key, def);
    }

    @Override
    protected void put(String key, String value) {
        editor.putString(key, value).apply();
    }

    @Override
    protected void remove(String key) {
        editor.remove(key).apply();
    }

    @Override
    protected void clear() {
        editor.clear().apply();
    }
}
