import 'dart:async';

import 'package:flutter/services.dart';

class AppInfo {
    static const MethodChannel _channel = const MethodChannel('dev.guoping.app_info');

    static String _platformVersion;
    static String _appId;
    static String _udid;
    static String _model;
    static String _appVerName;
    static double _appVerCode;
    static String _appChannel;

    static Future<String> get platformVersion async {
        if (_platformVersion == null) {
            _platformVersion = await _channel.invokeMethod('getPlatformVersion');
        }
        return _platformVersion;
    }

    static Future<String> get appId async {
        if (_appId == null) {
            _appId = await _channel.invokeMethod('getAppId');
        }
        return _appId;
    }

    static Future<String> get udid async {
        if (_udid == null) {
            _udid = await _channel.invokeMethod('getUdid');
        }
        return _udid;
    }

    static Future<String> get model async {
        if (_model == null) {
            _model = await _channel.invokeMethod('getModel');
        }
        return _model;
    }

    static Future<String> get appVerName async {
        if (_appVerName == null) {
            _appVerName = await _channel.invokeMethod('getAppVerName');
        }
        return _appVerName;
    }

    static Future<double> get appVerCode async {
        if (_appVerCode == null) {
            _appVerCode = await _channel.invokeMethod('getAppVerCode');
        }
        return _appVerCode;
    }

    static Future<String> get appChannel async {
        if (_appChannel == null) {
            _appChannel = await _channel.invokeMethod('getAppChannel');
        }
        return _appChannel;
    }
}
